<?php
/**********************************************************************
    Copyright (C) FrontAccounting, LLC.
	Released under the terms of the GNU General Public License, GPL, 
	as published by the Free Software Foundation, either version 3 
	of the License, or (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
    See the License here <http://www.gnu.org/licenses/gpl-3.0.html>.
***********************************************************************/
$page_security = 'SA_INWARD_AND_OUTWARD';
$path_to_root = "..";
include_once($path_to_root . "/purchasing/includes/po_class.inc");

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/purchasing/includes/purchasing_db.inc");
include_once($path_to_root . "/purchasing/includes/purchasing_ui.inc");

$js = "";
if ($SysPrefs->use_popup_windows)
	$js .= get_js_open_window(900, 500);
if (user_use_date_picker())
	$js .= get_js_date_picker();
//Receive Purchase Order Items
page(_($help_context = " Po Against Inward"), false, false, "", $js);

//---------------------------------------------------------------------------------------------------------------

if (isset($_GET['AddedID']))
{
	$grn = $_GET['AddedID'];
	$trans_type = ST_INWARD;

	display_notification_centered(_("Purchase Order Inward has been processed"));

	display_note(get_trans_view_str(ST_PURCHORDER, $grn, _("&View this Order")));
	
    $clearing_inward_act = get_company_pref('po_inward_act');
	if ($clearing_inward_act)	
		display_note(get_gl_view_str($trans_type, $grn, _("View the GL Journal Entries for this Outward")), 1);

	// hyperlink_params("$path_to_root/purchasing/supplier_invoice.php", _("Entry purchase &invoice for this receival"), "New=1");

	hyperlink_no_params("$path_to_root/purchasing/inquiry/po_search.php", _("Select a different &purchase order for receiving items against"));

	display_footer_exit();
}

//--------------------------------------------------------------------------------------------------

if ((!isset($_GET['PONumber']) || $_GET['PONumber'] == 0) && !isset($_SESSION['PO']))
{
	die (_("This page can only be opened if a purchase order has been selected. Please select a purchase order first."));
}

//--------------------------------------------------------------------------------------------------

function display_po_receive_items($kv_batch=0, $kv_exp_date=0)
{
	div_start('grn_items');
    start_table(TABLESTYLE, "colspan=7 width='90%'");
    $th = array(_("Item Code"), _("Description"), _("Ordered"), _("Units"), _("In Ward"), _("Out Ward"), _("Received"),	_("Outstanding"), _("This Inward"), _("Price"), _("Total"));
	// if($kv_exp_date){
	// 	array_splice( $th, 7, 0, _("Batch No") );
	// 	array_splice( $th, 8, 0, _("Exp Date") );
	// }elseif($kv_batch)
	// 	array_splice( $th, 7, 0, _("Batch No") );
	
    table_header($th);

    /*show the line items on the order with the quantity being received for modification */

    $total = 0;
    $k = 0; //row colour counter

    if (count($_SESSION['PO']->line_items)> 0 )
    {
       	foreach ($_SESSION['PO']->line_items as $ln_itm)
       	{

			alt_table_row_color($k);
            // display_error($ln_itm->quantity."- (".$ln_itm->qty_inward ."-".$ln_itm->qty_outward.")");
    		$qty_outstanding = $ln_itm->quantity - ($ln_itm->qty_inward-$ln_itm->qty_outward);

 			if (!isset($_POST['Update']) && !isset($_POST['ProcessGoodsReceived']) && $ln_itm->receive_qty == 0)
    	  	{   //If no quantites yet input default the balance to be received
    	    	$ln_itm->receive_qty = $qty_outstanding;
    		}

    		$line_total = ($ln_itm->receive_qty * $ln_itm->price);
    		$total += $line_total;

			label_cell($ln_itm->stock_id);
			if ($qty_outstanding > 0)
				text_cells(null, $ln_itm->stock_id . "Desc", $ln_itm->item_description, 30, 50);
			else
				label_cell($ln_itm->item_description);
			$dec = get_qty_dec($ln_itm->stock_id);
			qty_cell($ln_itm->quantity, false, $dec);
			label_cell($ln_itm->units);
			qty_cell($ln_itm->qty_inward, false, $dec);
			qty_cell($ln_itm->qty_outward, false, $dec);
			qty_cell($ln_itm->qty_received, false, $dec);
			qty_cell($qty_outstanding, false, $dec);

// display_error($ln_itm->qty_inward);
			if ($qty_outstanding > 0)
				qty_cells(null, $ln_itm->line_no, number_format2($ln_itm->receive_qty, $dec), "align=right", null, $dec);
			else
				label_cell(number_format2($ln_itm->receive_qty, $dec), "align=right");
			// if($kv_exp_date){
			// 	text_cells(null,$ln_itm->stock_id .'batch_no', null, 20, 20);
			// 	date_cells(null, $ln_itm->stock_id .'exp_date', '', null, 0, 0, 0);
			// } elseif($kv_batch){
			// 	text_cells(null,$ln_itm->stock_id .'batch_no', null, 20, 20);
			// 	hidden($ln_itm->stock_id .'exp_date', '');
			// } else{
			// 	hidden($ln_itm->stock_id .'batch_no', 0);
			// 	hidden($ln_itm->stock_id .'exp_date', '');
			// }
			//date_cells(null, $ln_itm->stock_id .'exp_date', '', null, 0, 0, 0);
			//month_year_cells(null, 'exp_date', null, null, 0, 0, 0);
			if(!$_SESSION["wa_current_user"]->can_access('SA_WORKORDERCOST'))
			{
			label_cell("-");
			label_cell("-");
			}
			else{

			amount_decimal_cell($ln_itm->price);
			amount_cell($line_total);
			}
			end_row();
       	}
    }

	$colspan = count($th)-1;

	$display_sub_total = price_format($total/* + input_num('freight_cost')*/);

	label_row(_("Sub-total"), $display_sub_total, "colspan=$colspan align=right","align=right");
	$taxes = $_SESSION['PO']->get_taxes(input_num('freight_cost'), true);
	
	$tax_total = display_edit_tax_items($taxes, $colspan, $_SESSION['PO']->tax_included);

	$display_total = price_format(($total + input_num('freight_cost') + $tax_total));

	start_row();
	label_cells(_("Amount Total"), $display_total, "colspan=$colspan align='right'","align='right'");
	end_row();
    end_table();
	div_end();
}

//--------------------------------------------------------------------------------------------------

function check_po_changed()
{
	/*Now need to check that the order details are the same as they were when they were read
	into the Items array. If they've changed then someone else must have altered them */
	// Compare against COMPLETED items only !!
	// Otherwise if you try to fullfill item quantities separately will give error.
	$result = get_po_items($_SESSION['PO']->order_no);

	$line_no = 0;
	while ($myrow = db_fetch($result))
	{
		$ln_item = $_SESSION['PO']->line_items[$line_no];
		// only compare against items that are outstanding
		$qty_outstanding = $ln_item->quantity - $ln_item->qty_received;
		if ($qty_outstanding > 0)
		{
    		if ($ln_item->qty_inv != $myrow["qty_invoiced"]	||
    			$ln_item->stock_id != $myrow["item_code"] ||
    			$ln_item->quantity != $myrow["quantity_ordered"] ||
    			$ln_item->qty_received != $myrow["quantity_received"])
    		{
    			return true;
    		}
		}
	 	$line_no++;
	} /*loop through all line items of the order to ensure none have been invoiced */

	return false;
}

//--------------------------------------------------------------------------------------------------

function can_process()
{
	global $SysPrefs;
	
	if (count($_SESSION['PO']->line_items) <= 0)
	{
        display_error(_("There is nothing to process. Please enter valid quantities greater than zero."));
    	return false;
	}

	if (!is_date($_POST['DefaultReceivedDate']))
	{
		display_error(_("The entered date is invalid."));
		set_focus('DefaultReceivedDate');
		return false;
	}
	if (!is_date_in_fiscalyear($_POST['DefaultReceivedDate'])) {
		display_error(_("The entered date is out of fiscal year or is closed for further data entry."));
		set_focus('DefaultReceivedDate');
		return false;
	}

	// if (!check_reference($_POST['ref'], ST_SUPPRECEIVE))
	// {
	// 	set_focus('ref');
	// 	return false;
	// }

	$something_received = 0;
	foreach ($_SESSION['PO']->line_items as $order_line)
	{
	  	if ($order_line->receive_qty > 0)
	  	{
			$something_received = 1;
			break;
	  	}
	}

    // Check whether trying to deliver more items than are recorded on the actual purchase order (+ overreceive allowance)
    $delivery_qty_too_large = 0;
	foreach ($_SESSION['PO']->line_items as $order_line)
	{
		// display_error($order_line->receive_qty."+".$order_line->qty_inward." - ".$order_line->qty_outward." == ".$order_line->quantity  );
	  	if ($order_line->receive_qty+($order_line->qty_inward-$order_line->qty_outward) >
	  		$order_line->quantity * (1+ ($SysPrefs->over_receive_allowance() / 100)))
	  	{
			$delivery_qty_too_large = 1;
			break;
	  	}
	}

    if ($something_received == 0)
    { 	/*Then dont bother proceeding cos nothing to do ! */
        display_error(_("There is nothing to process. Please enter valid quantities greater than zero."));
    	return false;
    }
    elseif ($delivery_qty_too_large == 1)
    {
    	display_error(_("Entered quantities cannot be greater than the quantity entered on the purchase order including the allowed over-receive percentage") . " (" . $SysPrefs->over_receive_allowance() ."%)."
    		. "<br>" .
    	 	_("Modify the ordered items on the purchase order if you wish to increase the quantities."));
    	return false;
    }

// exit();
// return false;
	return true;
}

//--------------------------------------------------------------------------------------------------

function process_receive_po()
{
	global $path_to_root, $Ajax;

	if (!can_process())
		return;

	if (check_po_changed())
	{
		display_error(_("This order has been changed or invoiced since this delivery was started to be actioned. Processing halted. To enter a delivery against this purchase order, it must be re-selected and re-read again to update the changes made by the other user."));

		hyperlink_no_params("$path_to_root/purchasing/inquiry/po_search.php",
		 _("Select a different purchase order for receiving goods against"));

		hyperlink_params("$path_to_root/purchasing/po_receive_items.php", 
			 _("Re-Read the updated purchase order for receiving goods against"),
			 "PONumber=" . $_SESSION['PO']->order_no);

		unset($_SESSION['PO']->line_items);
		unset($_SESSION['PO']);
		unset($_POST['ProcessGoodsReceived']);
		$Ajax->activate('_page_body');
		display_footer_exit();
	}
		begin_transaction();
	$grn = &$_SESSION['PO'];
	$grn->orig_order_date = $_POST['DefaultReceivedDate'];
	// $grn->reference = $_POST['ref'];
	// $grn->Location = $_POST['Location'];
	$grn->dc_no = ($_POST['dc_no']) ? $_POST['dc_no'] : 0;
		$grn->vehicle_no = $_POST['vehicle_no'];

	$grn->ex_rate = input_num('_ex_rate', null);
		$date_ = $grn->orig_order_date;
	// $grn_no = add_grn($grn);
    // update_for_partial_qc($grn->order_no);
    $clearing_inward_act = get_company_pref('po_inward_act');
        $clearing_act = get_company_pref('grn_clearing_act');
        
        
	if (!is_company_currency($grn->curr_code))
	{
		if (!$grn->ex_rate)
			$grn->ex_rate = get_date_exchange_rate($grn->curr_code, $date_);
		else
			add_new_exchange_rate($grn->curr_code, $date_, $grn->ex_rate);
	} else
		$grn->ex_rate = 1;        

  $total = 0;
	foreach ($grn->line_items as $line){


		 $sql = "INSERT INTO ".TB_PREF."inward_grn (type, order_no, po_line_id, ord_date, 
     	qty) VALUES(";
     $sql .= db_escape($grn->trans_type) . "," .
         db_escape($grn->order_no) . "," .
         db_escape($line->po_detail_rec) . ", " .
		 db_escape(date2sql($grn->orig_order_date)) . ", " .
         db_escape($line->receive_qty) . ")";

// display_error($sql);
   	db_query($sql, "The purchase order header record could not be inserted");

   		$sql = "UPDATE ".TB_PREF."purch_order_details SET in_ward_qty = in_ward_qty+".$line->receive_qty." WHERE po_detail_item=".db_escape($line->po_detail_rec);
  	db_query($sql, "Can't change PO update for again Inward ");

  	$stock_gl_code = get_stock_gl_code($line->stock_id);

			/*Update sales_order_details for the new quantity received and the standard cost used for postings to GL 
			  and recorded in the stock movements for FIFO/LIFO stocks valuations*/
			//------------------- update average material cost and clearing account --------------------------------
			if (is_inventory_item($line->stock_id))
			{
				if ($clearing_inward_act)
					$total += add_gl_trans_supplier(ST_INWARD, $grn->order_no, $date_, $clearing_inward_act,
						$stock_gl_code['dimension_id'], $stock_gl_code['dimension2_id'],
					    $line->taxfree_charge_value($grn), $grn->supplier_id, '', 0, $line->stock_id);
			}



	}

	if ($clearing_act && $total != 0.0) {
		$accs = get_supplier_accounts($grn->supplier_id);
		$total += add_gl_trans_supplier(ST_INWARD, $grn->order_no, $date_, $clearing_act,
			$accs['dimension_id'], $accs['dimension2_id'], -$total, null);
	}

  $po_no = $grn->order_no;

$sql = "UPDATE ".TB_PREF."purch_orders SET qc_req_date = '".date2sql($_POST['qc_req_date'])."' WHERE order_no=".db_escape($po_no);
// display_error($sql);
  	db_query($sql, "Can't change PO update for again Inward ");

  
  
commit_transaction();
	new_doc_date($_POST['DefaultReceivedDate']);
	unset($_SESSION['PO']->line_items);
	unset($_SESSION['PO']);

	meta_forward($_SERVER['PHP_SELF'], "AddedID=$po_no");
}

//--------------------------------------------------------------------------------------------------

if (isset($_GET['PONumber']) && $_GET['PONumber'] > 0 && !isset($_POST['Update']))
{
	create_new_po(ST_PURCHORDER, $_GET['PONumber']);
	$_SESSION['PO']->trans_type = ST_INWARD;
	// $_SESSION['PO']->reference = $Refs->get_next(ST_SUPPRECEIVE, 
	// 	array('date' => Today(), 'supplier' => $_SESSION['PO']->supplier_id));
	copy_from_cart();
}

//--------------------------------------------------------------------------------------------------

if (isset($_POST['Update']) || isset($_POST['ProcessGoodsReceived']))
{

	/* if update quantities button is hit page has been called and ${$line->line_no} would have be
 	set from the post to the quantity to be received in this receival*/
	foreach ($_SESSION['PO']->line_items as $line)
	{
	 if( ($line->quantity - $line->qty_received)>0) {
		$_POST[$line->line_no] = max($_POST[$line->line_no], 0);
		if (!check_num($line->line_no))
			$_POST[$line->line_no] = number_format2(0, get_qty_dec($line->stock_id));

		if (!isset($_POST['DefaultReceivedDate']) || $_POST['DefaultReceivedDate'] == "")
			$_POST['DefaultReceivedDate'] = new_doc_date();

		$_SESSION['PO']->line_items[$line->line_no]->receive_qty = input_num($line->line_no);

		if (isset($_POST[$line->stock_id . "Desc"]) && strlen($_POST[$line->stock_id . "Desc"]) > 0)
		{
			$_SESSION['PO']->line_items[$line->line_no]->item_description = $_POST[$line->stock_id . "Desc"];		

			$_SESSION['PO']->line_items[$line->line_no]->batch_no = $_POST[$line->stock_id . "batch_no"];
			$_SESSION['PO']->line_items[$line->line_no]->exp_date = $_POST[$line->stock_id . "exp_date"];
		}
	 }
	}
	$Ajax->activate('grn_items');
}

//--------------------------------------------------------------------------------------------------

if (isset($_POST['ProcessGoodsReceived']))
{
	process_receive_po();
}

//--------------------------------------------------------------------------------------------------
$kv_batch = get_company_pref('kv_batch');
$kv_exp_date = get_company_pref('kv_exp_date');
start_form();

// edit_grn_summary($_SESSION['PO'], true);
$po = &$_SESSION['PO'];
global $Refs;
	
	start_outer_table(TABLESTYLE2, "width='80%'");

	table_section(1);
		label_row(_("Supplier"), $po->supplier_name);

    	if (!is_company_currency($po->curr_code))
    		label_row(_("Order Currency"), $po->curr_code);

	    label_row(_("For Purchase Order"), get_trans_view_str(ST_PURCHORDER, $po->order_no));

		label_row(_("Ordered On"), $po->orig_order_date);

	table_section(2);
    	// if (!isset($_POST['ref']))
    	//     $_POST['ref'] = $Refs->get_next(ST_SUPPRECEIVE, null, array('supplier' => $po->supplier_id, 'date' => Today()));
    	// ref_row(_("Reference"), 'ref', '', null);

        // if (!isset($_POST['Location']))
        // 	$_POST['Location'] = $po->Location;

        // locations_list_row(_("Deliver Into Location"), "Location", $_POST['Location']);

    	if (!isset($_POST['DefaultReceivedDate']))
     	  	$_POST['DefaultReceivedDate'] = new_doc_date();

    	date_row(_("Date Items Received"), 'DefaultReceivedDate', '', true, 0, 0, 0, '', true);
    		date_row(_("QC Required Date"), 'qc_req_date', '', true, 0, 0, 0, '', true);

	table_section(3);
		// label_row(_("Supplier's Reference"), $po->supp_ref);

	   	label_row(_("Delivery Address"), $po->delivery_address);

    	if ($po->Comments != "")
    		label_row(_("Order Comments"), $po->Comments, "class='tableheader2'", "colspan=9");

    	// text_row_ex(_("DC #").':', 'dc_no', 20);
     //    text_row_ex(_("Vehicle #").':', 'vehicle_no', $_POST['vehicle_no'],"","",false, "class='tableheader2'");


		    if (!is_company_currency($po->curr_code)){
	    	if($po->ex_rate>1)
	    	$_POST['_ex_rate']= $po->ex_rate;
			exchange_rate_display(get_company_currency(), $po->curr_code, get_post('DefaultReceivedDate'));
	    }
	end_outer_table(1);
display_heading(_("Items to Inward"));
display_po_receive_items($kv_batch, $kv_exp_date);

echo '<br>';
submit_center_first('Update', _("Update"), '', true);
submit_center_last('ProcessGoodsReceived', _("Process Inward Items"), _("Clear all GL entry fields"), 'default');

end_form();

//--------------------------------------------------------------------------------------------------
end_page();
